#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2022/04/28 11:26
@Author: lxc
@LastEditTime: 
@Desctiption: 获取开关量综合报警 弹框提示的报警信息
"""

from abstract_api import AbstractApi
from event_storage import EventStorage

class GetMoxaE1210Alarm(AbstractApi):

    def operation(self, request):
        operate_mysql = EventStorage()

        io_point_name_dict = {}     # {'c365': '主配电板绝缘低', 'c366': '污水处理装置供电运行', 'c367': '污水处理装置综合报警', ...}
        select_io_point_name = "SELECT serial_number, io_point_name FROM `data_point_tbl` WHERE `station_name` = 'moxa_e1210' AND `io_point_name` IS NOT NULL;"
        io_point_name_res = operate_mysql.execute_sql(select_io_point_name)
        for each in io_point_name_res:
            io_point_name_dict["c" + str(each["serial_number"])] = each["io_point_name"]


        return_alarm_list = []
        select_sql = "SELECT CAST(update_time AS CHAR) AS update_time, serial_number FROM alarm_moxa_e1210 WHERE is_cancel=0;"
        alarm_datas = operate_mysql.execute_sql(select_sql)
        if alarm_datas:
            for each in alarm_datas:
                each_alarm = {
                    "alarm_time": each["update_time"],
                    "io_point_name": io_point_name_dict[each["serial_number"]]
                }

                return_alarm_list.append(each_alarm)

        return return_alarm_list

