#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2021/9/24 10:19
@Author: lxc
@LastEditTime: 
@Desctiption: 返回水下设备清洗的相关信息
"""


from abstract_api import AbstractApi
import datetime
from event_storage import EventStorage


class GetUnderwaterEquipCleanInfo(AbstractApi):

    def operation(self, request):
        operate_mysql = EventStorage()

        now_time = datetime.datetime.now()
        info_sql = "SELECT * FROM underwater_equipment_clean;"
        equip_info = operate_mysql.execute_sql(info_sql)
        result = []
        if len(equip_info) > 0:
            for each in equip_info:
                # 将清洗方法分行展示
                clean_method = each["clean_method"]
                clean_method = clean_method.replace("。", "。\n")
                each["clean_method"] = clean_method

                function_status = each["function_status"]
                status = 0
                if function_status == 1:
                    if now_time >= each["next_clean_time"]:
                        status = 1      # 设备是否需要清洗 0:不需要，1:需要
                each["status"] = status
                result.append(each)

        return result
