#!/usr/bin/env python
# encoding: utf-8
"""
@time: 2021/5/25 9:08
@desc: 关闭实时报警
"""

from abstract_api import AbstractApi
from event_storage import EventStorage
from log import OutPutLog


class CancelAlarm(AbstractApi):
    """关闭报警"""
    def __init__(self):
        self._log = OutPutLog()

    def operation(self, request):
        operate_mysql = EventStorage()
        id = request['id']
        if len(id) == 1:
            sql = "UPDATE alarm_data_tbl SET is_cancel=1 WHERE id=%s;" % (id[0])
        else:
            sql = "UPDATE alarm_data_tbl SET is_cancel=1 WHERE id in %s;" % (format(tuple(id)))
        try:
            operate_mysql.execute_sql(sql)
            return "告警关闭成功"
        except Exception as e:
            self._log.error(str(e))
            return "告警关闭失败"
