#!/usr/bin/env python
# encoding: utf-8
"""
@time: 2021/5/28 13:46
@desc: 修改设备维保信息：待维保天数和上次维保时间
"""


from abstract_api import AbstractApi
from event_storage import EventStorage
from datetime import datetime, timedelta
from dateutil.parser import parse
from log import OutPutLog


class ChangeMaintenanceInfo(AbstractApi):
    """更新设备的维保信息：待维保天数和上次维保时间"""

    def __init__(self):
        self._log = OutPutLog()

    def operation(self, request):
        operate_mysql = EventStorage()
        device_name = request['deviceName']
        last_maintenance_time = request['lastMaintenanceTime']
        maintenance_cycle = request['maintenanceCycle']

        now_time = datetime.now()
        today_time = now_time.strftime('%Y-%m-%d')

        # 下次维保时间
        next_maintenance_time = (datetime.strptime(last_maintenance_time, "%Y-%m-%d").date() + timedelta(days=maintenance_cycle)).strftime("%Y-%m-%d")
        waiting_days = (parse(next_maintenance_time) - parse(today_time)).days

        update_days = "UPDATE maintenance_information SET maintenance_cycle=%s, last_maintenance_time=\'%s\', waiting_days=%s WHERE device_name=\'%s\';" % (maintenance_cycle, last_maintenance_time, waiting_days, device_name)
        try:
            operate_mysql.execute_sql(update_days)
        except Exception as e:
            self._log.error(e)

        resturn_dict = {"device_name": device_name, "waiting_days": waiting_days}

        return resturn_dict