#!/usr/bin/env python
# encoding: utf-8
"""
@time: 2021/6/19 15:26
@desc: 智慧投饵接口
"""


from event_storage import EventStorage
from abstract_api import AbstractApi

class GetFeedingAdvise(AbstractApi):
    def operation(self, request):
        #投饵口朝向，1#:315°，2#:45°，3#:135°，4#:225°
        #风向：c1，风速：c2,流速：c7，流向：c8
        list = ["c1", "c2", "c7", "c8"]
        gateway_storage =  EventStorage()
        dict = gateway_storage.get_real_data(list)
        message = {}
        wind_speed = self.str_to_flaot(dict['c2'])
        wind_direction = self.str_to_flaot(dict['c1'])
        flow_speed = self.str_to_flaot(dict['c7'])
        flow_direction = self.str_to_flaot(dict['c8'])
        #判断投喂条件 ,错误或警告状态时port为0，系统不选择投喂口
        if wind_speed == None or wind_direction == None or flow_speed == None or flow_direction == None:
            message['type'] = "ERROR"
            message['port'] = 0
            message['content'] = "环境监测数据获取异常，请监测传感器状态！"
        else:
            if wind_speed > 17.2 or flow_speed > 1.0:
                message['type'] = "WARMING"
                message['port'] = 0
                message['content'] = "风速或流速过大，不建议进行投饵!"
            else:
                message['type'] = "NORMAL"
                if flow_direction < 180 and flow_direction > 90:
                    message['port'] = 1
                if flow_direction <= 90:
                    message['port'] = 2
                if flow_direction >= 180 and flow_direction < 270:
                    message['port'] = 1
                if flow_direction >= 270:
                    message['port'] = 2
                message['content'] = "建议使用%s号投饵口进行投饵" % (message['port'])
        return message

    def str_to_flaot(self, str):
        if str != None:
            return float(str)
        else:
            return None
