#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2021/6/21 14:48
@LastEditTime:
@Description: 获取 fishery_data 表的历史数据：返回每次投喂的总的情况，根据料灌编号、时间进行条件查询
"""

from abstract_api import AbstractApi
from event_storage import EventStorage
from log import OutPutLog

class GetFisheryDataAll(AbstractApi):

    def operation(self, request):

        operate_mysql = EventStorage()
        tank_num = request['tankNum']
        time_begin = request['timeBegin']

        if (tank_num is None) and (time_begin is None):
            # sql = "SELECT feed_id, MIN(times) AS time_begin, MAX(times) AS time_end, FORMAT(AVG(wind_speed),2) AS wind_speed, FORMAT(AVG(wind_direction),2) AS wind_direction, FORMAT(AVG(flow_speed),2) AS flow_speed, FORMAT(AVG(flow_direction),2) AS flow_direction, feeding_port, tank_number, FORMAT(AVG(feeder_frequency),2) AS feeder_frequency, FORMAT(AVG(fan_frequency),2) AS fan_frequency, FORMAT(SUM(feeding_amount),2) AS feeding_amount, feeding_mode, breed, bait_name, feed_weight, feed_diameter, shelf_life FROM fishery_data GROUP BY feed_id, feeding_port, tank_number, feeding_mode, breed, bait_name, feed_weight, feed_diameter, shelf_life;"
            sql = "SELECT feed_id, MIN(times) AS time_begin, MAX(times) AS time_end, FORMAT(AVG(wind_speed),2) AS wind_speed, " \
                  "FORMAT(AVG(wind_direction),2) AS wind_direction, FORMAT(AVG(flow_speed),2) AS flow_speed, " \
                  "FORMAT(AVG(flow_direction),2) AS flow_direction, FORMAT(AVG(feeder_frequency_1),2) AS feeder_frequency_1, " \
                  "FORMAT(AVG(fan_frequency_1),2) AS fan_frequency_1, FORMAT(AVG(feeder_frequency_2),2) AS feeder_frequency_2, " \
                  "FORMAT(AVG(fan_frequency_2),2) AS fan_frequency_2, FORMAT(SUM(feeding_amount_1),2) AS feeding_amount_1, " \
                  "FORMAT(SUM(feeding_amount_2),2) AS feeding_amount_2, feeding_mode, breed, bait_name_1, bait_name_2, " \
                  "feed_weight_1, feed_weight_2, feed_diameter_1, feed_diameter_2, shelf_life_1, shelf_life_2 " \
                  "FROM fishery_data " \
                  "GROUP BY feed_id, feeding_mode, breed, bait_name_1, bait_name_2, feed_weight_1, feed_weight_2, feed_diameter_1, feed_diameter_2, shelf_life_1, shelf_life_2;"
        elif (tank_num is None) and (time_begin is not None):
            time_begin = time_begin + " 00:00:00"
            time_end = request['timeEnd'] + " 23:59:59"
            # sql = "SELECT feed_id, MIN(times) AS time_begin, MAX(times) AS time_end, FORMAT(AVG(wind_speed),2) AS wind_speed, FORMAT(AVG(wind_direction),2) AS wind_direction, FORMAT(AVG(flow_speed),2) AS flow_speed, FORMAT(AVG(flow_direction),2) AS flow_direction, feeding_port, tank_number, FORMAT(AVG(feeder_frequency),2) AS feeder_frequency, FORMAT(AVG(fan_frequency),2) AS fan_frequency, feed_diameter, shelf_life FROM fishery_data WHERE times BETWEEN \'%s\' and \'%s\' GROUP BY feed_id, feeding_port, tank_number,feeding_mode, breed, bait_name, feed_weight, feed_diameter, shelf_life;" % (time_begin, time_end)
            sql = "SELECT feed_id, MIN(times) AS time_begin, MAX(times) AS time_end, FORMAT(AVG(wind_speed),2) AS wind_speed, " \
                  "FORMAT(AVG(wind_direction),2) AS wind_direction, FORMAT(AVG(flow_speed),2) AS flow_speed, " \
                  "FORMAT(AVG(flow_direction),2) AS flow_direction, FORMAT(AVG(feeder_frequency_1),2) AS feeder_frequency_1, " \
                  "FORMAT(AVG(fan_frequency_1),2) AS fan_frequency_1, FORMAT(AVG(feeder_frequency_2),2) AS feeder_frequency_2, " \
                  "FORMAT(AVG(fan_frequency_2),2) AS fan_frequency_2, FORMAT(SUM(feeding_amount_1),2) AS feeding_amount_1, " \
                  "FORMAT(SUM(feeding_amount_2),2) AS feeding_amount_2, feeding_mode, breed, bait_name_1, bait_name_2, " \
                  "feed_weight_1, feed_weight_2, feed_diameter_1, feed_diameter_2, shelf_life_1, shelf_life_2 " \
                  "FROM fishery_data " \
                  "WHERE times BETWEEN \'%s\' and \'%s\' " \
                  "GROUP BY feed_id, feeding_mode, breed, bait_name_1, bait_name_2, feed_weight_1, feed_weight_2, feed_diameter_1, feed_diameter_2, shelf_life_1, shelf_life_2;" % (time_begin, time_end)
        elif (tank_num is not None) and (time_begin is None):
            # sql = "SELECT feed_id, MIN(times) AS time_begin, MAX(times) AS time_end, FORMAT(AVG(wind_speed),2) AS wind_speed, FORMAT(AVG(wind_direction),2) AS wind_direction, FORMAT(AVG(flow_speed),2) AS flow_speed, FORMAT(AVG(flow_direction),2) AS flow_direction, feeding_port, tank_number, FORMAT(AVG(feeder_frequency),2) AS feeder_frequency, FORMAT(AVG(fan_frequency),2) AS fan_frequency, FORMAT(SUM(feeding_amount),2) AS feeding_amount, feeding_mode, breed, bait_name, feed_weight, feed_diameter, shelf_life FROM fishery_data WHERE tank_number=%s GROUP BY feed_id, feeding_port, tank_number,feeding_mode, breed, bait_name, feed_weight, feed_diameter, shelf_life;" % (tank_num)
            sql = "SELECT feed_id, MIN(times) AS time_begin, MAX(times) AS time_end, FORMAT(AVG(wind_speed),2) AS wind_speed, " \
                  "FORMAT(AVG(wind_direction),2) AS wind_direction, FORMAT(AVG(flow_speed),2) AS flow_speed, " \
                  "FORMAT(AVG(flow_direction),2) AS flow_direction, FORMAT(AVG(feeder_frequency_1),2) AS feeder_frequency_1, " \
                  "FORMAT(AVG(fan_frequency_1),2) AS fan_frequency_1, FORMAT(AVG(feeder_frequency_2),2) AS feeder_frequency_2, " \
                  "FORMAT(AVG(fan_frequency_2),2) AS fan_frequency_2, FORMAT(SUM(feeding_amount_1),2) AS feeding_amount_1, " \
                  "FORMAT(SUM(feeding_amount_2),2) AS feeding_amount_2, feeding_mode, breed, bait_name_1, bait_name_2, " \
                  "feed_weight_1, feed_weight_2, feed_diameter_1, feed_diameter_2, shelf_life_1, shelf_life_2 " \
                  "FROM fishery_data WHERE tank_number=%s " \
                  "GROUP BY feed_id, feeding_mode, breed, bait_name_1, bait_name_2, feed_weight_1, feed_weight_2, feed_diameter_1, feed_diameter_2, shelf_life_1, shelf_life_2;" % (tank_num)
        elif (tank_num is not None) and (time_begin is not None):
            time_begin = time_begin + " 00:00:00"
            time_end = request['timeEnd'] + " 23:59:59"
            # sql = "SELECT feed_id, MIN(times) AS time_begin, MAX(times) AS time_end, FORMAT(AVG(wind_speed),2) AS wind_speed, FORMAT(AVG(wind_direction),2) AS wind_direction, FORMAT(AVG(flow_speed),2) AS flow_speed, FORMAT(AVG(flow_direction),2) AS flow_direction, feeding_port, tank_number, FORMAT(AVG(feeder_frequency),2) AS feeder_frequency, FORMAT(AVG(fan_frequency),2) AS fan_frequency, FORMAT(SUM(feeding_amount),2) AS feeding_amount, feeding_mode, breed, bait_name, feed_weight, feed_diameter, shelf_life FROM fishery_data WHERE tank_number=%s and times BETWEEN \'%s\' and \'%s\' GROUP BY feed_id, feeding_port, tank_number,feeding_mode, breed, bait_name, feed_weight, feed_diameter, shelf_life;" % (tank_num, time_begin, time_end)
            sql = "SELECT feed_id, MIN(times) AS time_begin, MAX(times) AS time_end, FORMAT(AVG(wind_speed),2) AS wind_speed, " \
                  "FORMAT(AVG(wind_direction),2) AS wind_direction, FORMAT(AVG(flow_speed),2) AS flow_speed, " \
                  "FORMAT(AVG(flow_direction),2) AS flow_direction, FORMAT(AVG(feeder_frequency_1),2) AS feeder_frequency_1, " \
                  "FORMAT(AVG(fan_frequency_1),2) AS fan_frequency_1, FORMAT(AVG(feeder_frequency_2),2) AS feeder_frequency_2, " \
                  "FORMAT(AVG(fan_frequency_2),2) AS fan_frequency_2, FORMAT(SUM(feeding_amount_1),2) AS feeding_amount_1, " \
                  "FORMAT(SUM(feeding_amount_2),2) AS feeding_amount_2, feeding_mode, breed, bait_name_1, bait_name_2, " \
                  "feed_weight_1, feed_weight_2, feed_diameter_1, feed_diameter_2, shelf_life_1, shelf_life_2 " \
                  "FROM fishery_data " \
                  "WHERE tank_number=%s and times BETWEEN \'%s\' and \'%s\' " \
                  "GROUP BY feed_id, feeding_mode, breed, bait_name_1, bait_name_2, feed_weight_1, feed_weight_2, feed_diameter_1, feed_diameter_2, shelf_life_1, shelf_life_2;" % (tank_num, time_begin, time_end)


        datas = operate_mysql.execute_sql(sql)
        if datas is not None:
            feed_amount = 0
            for each in datas:
                feed_amount = feed_amount + float(each['feeding_amount_1'].replace(',', '')) + float(each['feeding_amount_2'].replace(',', ''))
            all_feed_amount = {"feed_amount": "%.2f" % float(feed_amount)}
            return datas, all_feed_amount
        else:
            return "find error"
