#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime:    2021/6/19 9:47
@LastEditTime:
@Description: 获取自动投喂的配置信息，默认有10条数据，全部查询
"""


from abstract_api import AbstractApi
from event_storage import EventStorage

class GetLastTimeFeedingData(AbstractApi):

    def operation(self, request):
        operate_mysql = EventStorage()
        # 1号供料器频率：c653
        # 1号供料器频率：c661        
        list = ["c653", "c661"]
        real_data_dict = operate_mysql.get_real_data(list)
        feeder_frequency = self.str_to_flaot(real_data_dict['c653'])+self.str_to_flaot(real_data_dict['c661'])
        if feeder_frequency > 1:
            sql = "SELECT SUM(feeding_amount_1),SUM(feeding_amount_2) FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data WHERE feed_id < (select max(feed_id) from fishery_data));"
            feeding_amount = operate_mysql.execute_sql(sql)

            sql = "SELECT times,shelf_life_1,shelf_life_2 FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data WHERE feed_id < (select max(feed_id) from fishery_data)) ORDER BY times LIMIT 1;"
            datas = operate_mysql.execute_sql(sql)

        else:
            sql = "SELECT SUM(feeding_amount_1),SUM(feeding_amount_2) FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data);"
            feeding_amount = operate_mysql.execute_sql(sql)

            #sql = "SELECT times,shelf_life_1,shelf_life_2 FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data) ORDER BY times LIMIT 1;"
            sql = "SELECT times,shelf_life_1,shelf_life_2 FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data) ORDER BY id LIMIT 1;"
            datas = operate_mysql.execute_sql(sql)

        if datas is not None:
            if len(datas) != 0:
                dict_datas = {}
                dict_each_1 = {}
                dict_each_1['feeding_amount'] = round(feeding_amount[0]['SUM(feeding_amount_1)'],2)
                dict_each_1['times'] = datas[0]['times']
                dict_each_1['tank_number'] = 1
                dict_each_1['shelf_life'] = datas[0]['shelf_life_1']
                dict_each_1['food_fall'] = 0
                dict_each_2 = {}
                dict_each_2['feeding_amount'] = round(feeding_amount[0]['SUM(feeding_amount_2)'],2)
                dict_each_2['times'] = datas[0]['times']
                dict_each_2['tank_number'] = 2
                dict_each_2['shelf_life'] = datas[0]['shelf_life_2']
                dict_each_2['food_fall'] = 0                
                dict_datas["tank1"] = dict_each_1
                dict_datas["tank2"] = dict_each_2                
                return dict_datas
            else:
                return None
        else:
            return "查询出错，请看日志"

    def str_to_flaot(self, str):
        if str != None:
            return float(str)
        else:
            return 0

