#!/usr/bin/python3


# modbus tcp 连接器
import time
import modbus_tk.modbus_tcp as modbus_tcp
def modbus_tcp_conn(conn_info):
    try:
        ip = conn_info['ip']
        port = conn_info['port']
        device_id = conn_info['device_id']
        function_code = conn_info['function_code']
        start_addr = conn_info['start_addr']

        master = modbus_tcp.TcpMaster(ip, port)
        master.set_timeout(5.0)
        print(f"{ip}:{port} connect success! ")

        while 1:
            if function_code in (1, 2, 3, 4):
                # 读取数据
                length = conn_info['length']
                res_data = master.execute(device_id, function_code, start_addr, length)
            elif function_code in (5, 6, 15, 16):
                # 写寄存器
                output_value = conn_info['output_value']
                res_data = master.execute(device_id, function_code, start_addr, output_value=output_value)

            else:
                res_data = f'Unsupported function code. {function_code}'
            print(res_data)
            time.sleep(5)

    except Exception as e:
        print(f"[modbus_tcp_conn ERROR]：{e}")


modbus_tcp_conn_info = {
    "ip": "192.168.4.246",
    "port": 1030,
    "device_id": 1,
    "function_code": 1,
    "start_addr": 0,
    "length": 8,
    "output_value": []
}
# modbus_tcp_conn(modbus_tcp_conn_info)





import modbus_tk.modbus_tcp as modbus_tcp
import traceback
def modbus_tcp_conn():
    # 初始化
    ip = "192.168.4.246"
    port = 1030

    conn = False
    try:
        master = modbus_tcp.TcpMaster(ip, port)
        master.set_timeout(1.0)
        print(f"{ip}:{port} connect success!")
        conn = True
    except ConnectionRefusedError:
        print("ConnectionRefusedError")
    except Exception as e:
        print(f"e = {e}")

    # 读取数据
    try:
        receive_data = master.execute(1, 1, 0, 4)
        print("receive_data = ", receive_data)
    except Exception as e:
        print("eeee---", e)



#modbus_tcp_conn()


import modbus_rtu_over_tcp_special

def modbus_rtu_over_tcp():

    ip = "192.168.4.48"
    port = 4001
    try:
        master = modbus_rtu_over_tcp_special.RtuOverTcpMasterSpecial(host=ip, port=port)
        receive_data = master.execute(203, 3, 0, 4)
        print(receive_data)
    
    except Exception as e:
        print(e)


modbus_rtu_over_tcp()









