#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime:    2021/6/19 9:47
@LastEditTime:
@Description: 获取自动投喂的配置信息，默认有10条数据，全部查询
"""


from abstract_api import AbstractApi
from event_storage import EventStorage

class GetAutoFeedInfo(AbstractApi):

    def operation(self, request):
        operate_mysql = EventStorage()

        sql = "SELECT id, mode, feeding_port, feeding_line, CAST(time_begin AS CHAR) as time_begin, date_bait, CAST(time_end AS CHAR) as time_end, feeding_amount, bait_fall_regulation, phase_frequency, activation FROM automatic_feeding_configuration;"
        datas = operate_mysql.execute_sql(sql)
        weekStr = "周日周一周二周三周四周五周六"
        # port_info_list = ["1号口","2号口"]

        if datas is not None:
            if len(datas) != 0:
                list_data = []
                for each in datas:
                    dict_each = {}
                    for k in each:
                        # select 会将查到的json格式的值转为str，这里将其转为dict格式，以便返回json格式的字符串
                        if k == 'phase_frequency' and each[k] is not None:
                            dict_each[k] = eval(each[k])
                        elif k == 'date_bait':
                            list_week = []
                            for date in eval(each[k]):
                                list_week.append(weekStr[date*2: date*2+2])
                            dict_each[k] = list_week
                        # elif k == 'feeding_port':
                        #     dict_each[k] = port_info_list[each[k]]
                        else:
                            dict_each[k] = each[k]
                    list_data.append(dict_each)
                return list_data
            else:
                return None
        else:
            return "查询出错，请看日志"
