from abstract_api import AbstractApi
from event_storage import EventStorage

class GetEachDepthData(AbstractApi):
    def operation(self, request):
        """
        c12：溶解度，solubility
        c13：温度，temperature
        c14：盐度，salt
        c15：PH
        c16：叶绿素，chlorophyll
        c17：深度, depth
        :param request: 
        :return: 
        """
        operate_mysql = EventStorage()
        begin_time = request['timeBegin']
        end_time = request['timeEnd']

        solubility = []
        temperature = []
        salt = []
        ph = []
        chlorophyll = []
        depth = []
        sql_datas = "SELECT avg(c12),avg(c13),avg(c14),avg(c15),avg(c16),avg(c17) FROM table_shuizhi WHERE times BETWEEN \'%s\' AND \'%s\' GROUP BY ROUND(c17,1) ORDER BY ROUND(c17,1);" % (begin_time, end_time)
        res_datas = operate_mysql.execute_sql(sql_datas)
        for each in res_datas:
            try:
                if each['avg(c12)'] is not None:
                    solubility.append(round(each['avg(c12)'], 2))
                else:
                    solubility.append(None)

                if each['avg(c13)'] is not None:
                    temperature.append(round(each['avg(c13)'], 2))
                else:
                    temperature.append(None)

                if each['avg(c14)'] is not None:
                    salt.append(round(each['avg(c14)'], 2))
                else:
                    salt.append(None)

                if each['avg(c15)'] is not None:
                    ph.append(round(each['avg(c15)'], 2))
                else:
                    ph.append(None)

                if each['avg(c16)'] is not None:
                    chlorophyll.append(round(each['avg(c16)'], 2))
                else:
                    chlorophyll.append(None)

                if each['avg(c17)'] is not None:
                    depth.append(str(round(each['avg(c17)'], 2)) + 'm')
                else:
                    depth.append(None)
            except Exception as e:
                print("[GetEachDepthData] ERROR", e)

        return_datas = {
                "solubility": solubility,
                "temperature": temperature,
                "salt": salt,
                "ph": ph,
                "chlorophyll": chlorophyll,
                "depth": depth
            }

        return return_datas

