#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2023/01/09 15:09
@Author: lxc
@LastEditTime: 
@Desctiption: 获取多个参数的历史曲线数据
"""


from abstract_api import AbstractApi
from event_storage import EventStorage

class GetHistoryCurveData(AbstractApi):

    def operation(self, request):
        operate_mysql = EventStorage()
        serial_number = request['serial_number']
        begin_time = request['timeBegin']
        end_time = request['timeEnd']

        # 查该序列号对应的表名
        return_data = {
            "t": []
        }
        for each in serial_number:
            # {'t': [], 'c869': [], 'c870': [], 'c871': [], 'c872': [], 'c873': [], 'c874': []}
            return_data[each] = []
        sql_table_name = "SELECT device_name FROM data_point_tbl WHERE serial_number=%s" % (serial_number[0].replace('c', ''))
        res_table_name = operate_mysql.execute_sql(sql_table_name)
        if res_table_name:
            table_name = "table_" + res_table_name[0]['device_name']

            if table_name != 'table_laliji':
                serial_number = str(serial_number)[1:-1].replace("'", "")
                sql_data = "SELECT CAST(times AS CHAR) as t, %s FROM %s WHERE times BETWEEN \'%s\' and \'%s\' " \
                           "ORDER BY times;" % (serial_number, table_name, begin_time, end_time)

                res_data = operate_mysql.execute_sql(sql_data)
                for each in res_data:
                    for k, v in each.items():
                        # print(k,v)
                        return_data[k].append(v)

            else:
                # 拉力计的数据需要特殊计算
                sql_data = "SELECT CAST(times AS CHAR) as t,c869,c870,c871,c872,c873,c874,c875,c876,c877,c878,c879," \
                           "c880,c881,c882,c883,c884,c885,c886,c887,c888,c889,c890,c891,c892  FROM %s WHERE times " \
                           "BETWEEN \'%s\' and \'%s\' ORDER BY times;" % (table_name, begin_time, end_time)
                res_data = operate_mysql.execute_sql(sql_data)

                serial_dict = {
                    'c869': ['c875', 'c876', 'c877'],
                    'c870': ['c878', 'c879', 'c880'],
                    'c871': ['c881', 'c882', 'c883'],
                    'c872': ['c884', 'c885', 'c886'],
                    'c873': ['c887', 'c888', 'c889'],
                    'c874': ['c890', 'c891', 'c892']
                }
                for each in res_data:
                    # each = {'t': '2023-02-01 11:08:50', 'c869': 3.0, 'c870': 6.0, 'c871': 4.0, 'c872': 2.0}
                    return_data['t'].append(each['t'])

                    for k, v in serial_dict.items():
                        original = each[k]  # S485读取的无符号整数
                        a = each[v[0]]      # 参数A
                        b = each[v[1]]      # 参数B
                        f0 = each[v[2]]     # 参数f0
                        if original and original == 0:
                            return_data[k].append(0)
                        elif original and original != 0 and a and b and f0:
                            f = 80000000 / original         # 受力时频率f=80000000/（S485读取的无符号整数）
                            p = a*(f*f-f0*f0) - b*(f-f0)        # P=A(f²-f0²)-B(f-f0)
                            return_data[k].append(round(p, 2))
                        else:
                            return_data[k].append(None)

        return return_data
