#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime:    2021/6/19 9:47
@LastEditTime:
@Description: 获取自动投喂的配置信息，默认有10条数据，全部查询
"""


from abstract_api import AbstractApi
from event_storage import EventStorage

class GetLastTimeFeedingData(AbstractApi):

    def operation(self, request):
        operate_mysql = EventStorage()

        # 旋转输料器1号运行频率：c445
        # 旋转输料器2号运行频率：c446
        # 旋转输料器3号运行频率：c447
        # 旋转输料器4号运行频率：c448
        list = ["c445", "c446", "c447", "c448"]

        real_data_dict = operate_mysql.get_real_data(list)
        feeder_frequency = self.str_to_flaot(real_data_dict['c445']) + self.str_to_flaot(real_data_dict['c446']) + self.str_to_flaot(real_data_dict['c447']) + self.str_to_flaot(real_data_dict['c448'])
        if feeder_frequency > 1:
            sql = "SELECT SUM(feeding_amount) FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data WHERE feed_id < (select max(feed_id) from fishery_data));"
            feeding_amount = operate_mysql.execute_sql(sql)

            sql = "SELECT times,tank_number,shelf_life FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data WHERE feed_id < (select max(feed_id) from fishery_data)) ORDER BY times LIMIT 1;"
            datas = operate_mysql.execute_sql(sql)
        else:
            sql = "SELECT SUM(feeding_amount) FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data);"
            feeding_amount = operate_mysql.execute_sql(sql)

            sql = "SELECT times,tank_number,shelf_life FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data) ORDER BY times LIMIT 1;"
            datas = operate_mysql.execute_sql(sql)

        parame = {1, 2, 3, 4}

        if datas is not None:
            if len(datas) != 0:
                parame.remove(datas[0]['tank_number'])
                dict_datas = {}
                dict_each = {}
                dict_each['feeding_amount'] = round(feeding_amount[0]['SUM(feeding_amount)'], 2)
                dict_each['times'] = datas[0]['times']
                dict_each['tank_number'] = datas[0]['tank_number']
                dict_each['shelf_life'] = datas[0]['shelf_life']
                dict_each['food_fall'] = 0
                dict_datas["tank" + str(dict_each['tank_number'])] = dict_each

                for tank_number in parame:
                    sql = "SELECT SUM(feeding_amount) FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data WHERE tank_number = %s );" % (tank_number)
                    feeding_amount = operate_mysql.execute_sql(sql)

                    sql = "SELECT times,tank_number,shelf_life FROM fishery_data WHERE feed_id = (select max(feed_id) from fishery_data WHERE tank_number = %s) ORDER BY times LIMIT 1;" % (tank_number)
                    datas = operate_mysql.execute_sql(sql)
                    if datas is not None:
                        if len(datas) != 0:
                            dict_each = {}
                            dict_each['feeding_amount'] = round(feeding_amount[0]['SUM(feeding_amount)'], 2)
                            dict_each['times'] = datas[0]['times']
                            dict_each['tank_number'] = datas[0]['tank_number']
                            dict_each['shelf_life'] = datas[0]['shelf_life']
                            dict_each['food_fall'] = 0
                            dict_datas["tank" + str(dict_each['tank_number'])] = dict_each

                return dict_datas
            else:
                return None
        else:
            return "查询出错，请看日志"

    def str_to_flaot(self, str):
        if str != None:
            return float(str)
        else:
            return 0

