#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2023/06/13 08:59
@Author: lxc
@LastEditTime: 
@Desctiption: 根据传入的月份，返回机器人指定月份的所有日期
"""


from abstract_api import AbstractApi
from log import OutPutLog
from apis.operate_mysql import OperateMysql


class RobotGetAllDate(AbstractApi):

    def operation(self, request):
        """
        根据传入的月份，返回机器人指定月份的所有日期
        @param request: {"rovid" : "xunjian1", "month": "2023-06"}
        @return:[{time: "2023-06-08"}, {time: "2023-06-09"}, {time: "2023-06-10"},…]
        """

        self._log = OutPutLog()
        operate_mysql = OperateMysql(db="robotDataBase")
        rovid = request['rovid']
        month = request['month']

        sql = f"SELECT DATE_FORMAT(createtime, '%Y-%m-%d') AS time FROM `rov1position` " \
              f"WHERE `rovid`='{rovid}' AND `createtime` LIKE '{month}%' GROUP BY time;"
        res = operate_mysql.execute_sql(sql)

        return res


