#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2023/06/13 09:37
@Author: lxc
@LastEditTime: 
@Desctiption: 返回机器人指定日期的坐标
"""

from abstract_api import AbstractApi
from log import OutPutLog
from apis.operate_mysql import OperateMysql


class RobotGetHistoryPositionData(AbstractApi):

    def operation(self, request):
        """
        返回机器人指定日期的坐标
        @param request: {"rovid" : "xunjian1", "date": "2023-06-12"}
        @return:[{time: "2023-06-08"}, {time: "2023-06-09"}, {time: "2023-06-10"},…]
        """

        self._log = OutPutLog()
        operate_mysql = OperateMysql(db="robotDataBase")
        rovid = request['rovid']
        date = request['date']

        sql = f"SELECT position_x AS x,position_y AS y,position_z AS z FROM `rov1position` WHERE `rovid`='{rovid}' AND `createtime` LIKE '{date}%' ORDER BY `createtime`;"
        res = operate_mysql.execute_sql(sql)

        return res