#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2022/06/30 16:53
@Author: lxc
@LastEditTime:
@Desctiption: 获取 水下云台水下灯等设备定时开关 的相关信息
"""

import json
from abstract_api import AbstractApi
from event_storage import EventStorage

class YuntaidengGetMode(AbstractApi):
    """获取 水下云台水下灯等设备定时开关 的相关信息"""

    def operation(self, request):
        operate_mysql = EventStorage()

        sql = "SELECT device_name,control_mode,definite_time FROM shuixiayuntaideng_control;"
        datas = operate_mysql.execute_sql(sql)
        for data in datas:
            # {'device_name': 'shuixiayuntai01', 'control_mode': 1, 'definite_time': '[["06:00:00,07:59:59"]]\t'}
            definite_time = json.loads(data["definite_time"])
            time_dict = []
            for each_time in definite_time:
                t1, t2 = each_time.split(",")
                time_dict.append([t1, t2])
            data["definite_time"] = time_dict

        return datas
