#!/usr/bin/env python
# encoding: utf-8
"""
@CreateTime: 2023/02/01 09:50
@Author: lxc
@LastEditTime: 
@Desctiption: 实时获取拉力计 计算公式的参数，并存入redis中
"""

from event_storage import EventStorage
from log import OutPutLog
import time
from datetime import datetime

class GetLalijiParam:
    def __init__(self):
        self._storage = EventStorage()
        self._log = OutPutLog()

    def run(self):
        self._log.info("[GetLalijiParam] - GetLalijiParam module is running!")

        # 拉力计1-6原始数据
        serial_list = ['c869', 'c870', 'c871', 'c872', 'c873', 'c874']
        run_time = 0
        while True:
            this_time = time.time()
            if this_time - run_time > 5:
                run_time = this_time

                real_data_dict = self._storage.get_real_data(serial_list)
                status = False
                for v in real_data_dict.values():
                    if v is not None:
                        status = True

                if status:
                    self.save_param()

    def save_param(self):
        """实时获取拉力计 计算公式的参数，并存入redis中"""
        get_param_sql = "SELECT `serial_number`,`value` FROM `laliji_config`;"
        param_res = self._storage.execute_sql(get_param_sql)
        param_dict = {}
        for each in param_res:
            param_dict[each['serial_number']] = each['value']
        self._storage.real_time_data_storage(param_dict)

