#!/usr/bin/python3


"""控制聚鱼灯开关"""
import time
from modbus_tk import modbus_rtu_over_tcp
def juyudeng():
    # 开启光敏模式    photosense_1= {"device_id":1, "function_code":5, "start_addr":2, "output_value":0}
    # 关闭光敏模式    photosense_0={"device_id":1, "function_code":5, "start_addr":2, "output_value":65280}
    # 开启聚鱼灯     light_1={"device_id":1, "function_code":15, "start_addr":0, "output_value":[1, 1, 0 ,0]}
    # 关闭聚鱼灯     light_0={"device_id":1, "function_code":15, "start_addr":0, "output_value":[0, 0, 0 ,0]}

    master = modbus_rtu_over_tcp.RtuOverTcpMaster(host="192.168.6.100", port=1030)
    print('connected')

    # res = master.execute(1, 5, 2, output_value=65280)               # 光敏关：01 05 00 02 FF 00 2D FA
    # res = master.execute(1, 5, 2, output_value=0)                   # 光敏开：01 05 00 02 00 00 6C 0A
    # res = master.execute(1, 15, 0, output_value=[1, 1, 0, 0])       # 聚鱼灯关 01 0F 00 00 00 04 01 01 01 00 00 5E 50
    # res = master.execute(1, 15, 0, output_value=[0, 1, 0, 0])       # 聚鱼灯开 01 0F 00 00 00 04 00 00 01 00 00 62 6C


    # 新的指令
    # res = master.execute(1, 5, 2, output_value=65280)               # 光敏关：01 05 00 02 FF 00 2D FA
    res = master.execute(1, 5, 2, output_value=0)                   # 光敏开：01 05 00 02 00 00 6C 0A
    # res = master.execute(1, 15, 0, output_value=[1, 1, 0, 0])       # 聚鱼灯开 01 0F 00 00 00 04 01 01 01 00 00 5E 50
    res = master.execute(1, 15, 0, output_value=[0, 0, 0, 0])       # 聚鱼灯关 01 0F 00 00 00 04 00 00 00 00 00 33 AC
    print(res)
    master.close()

# juyudeng()


import modbus_tk.modbus_tcp as modbus_tcp

def modbus_tcp_conn():
    # 初始化
    master = modbus_tcp.TcpMaster("192.168.6.41", 502)
    master.set_timeout(5.0)
    print("connect success! ")
    # 读取数据
    # receive_data = master.execute(1, 3, 4712, 2)
    receive_data = master.execute(1, 3, 1032, 3)

    print(receive_data)

# modbus_tcp_conn()



from modbus_tk import modbus_rtu_over_tcp
def modbus_rtu_over_tcp_conn():
    ip = "192.168.5.232"
    port = 4002
    device_id = 101
    function_code = 3
    start_addr = 0
    length = 10

    try:
        master = modbus_rtu_over_tcp.RtuOverTcpMaster(host=ip, port=port)
        master.set_timeout(10.0)
        master.set_verbose(True)
        receive_data = master.execute(device_id, function_code, start_addr, length)
        print("receive_data=", receive_data)
    except Exception as e:
        print(e)

# modbus_rtu_over_tcp_conn()




from libs.hls import SiemensS7Net
from libs.hls import SiemensPLCS
def conn_s7():
    ip = "192.168.6.211"
    port = 102
    # start_addr = "DB13.116"
    start_addr = "M20"
    length = 1

    try:
        master = SiemensS7Net(SiemensPLCS.S200Smart, ip, port)
        if master.ConnectServer().IsSuccess == True:
            print("connect success!")
            result = master.Read(start_addr, length)
            data = {}
            if result.IsSuccess:
                data[start_addr] = result.Content
                print("data = ", data)
            else:
                print("result.Message =", result.Message)
        else:
            print("connect failed")
    except Exception as e:
        print("e = ", e)


    format_data_dict = {}  # 列表数据转换字典数字
    address = ["M20.1", "M20.2", "M20.3", "M20.4", "M20.5"]
    for addr in address:
        if addr.startswith("DB"):
            addr = address_transform(addr)  # 以 DB13.DBX395.1 为例：DB13.395.1
            addr_division = "".join(addr).split(".")  # ['DB13', '395', '1']
            db_number = addr_division[0]  # DB13
            data_addr = int(addr_division[1])  # 395

        elif addr.startswith("M"):
            # data =  {'M0': bytearray(b';\x04\x00\x00')}
            addr_division = addr.split(".")  # 以"M20.6"为例，["M20", "6"]
            db_number = addr_division[0]
            data_addr = 0

            if db_number in data:
                if data[db_number] != None:  # 防止设备断线返回为空导致的异常
                    print(data[db_number])

                    # if type == "BOOL":
                    return_data = int(master.byteTransform.TransBoolArray(data[db_number], data_addr, 1)[int(addr_division[-1])])
                    format_data_dict[addr] = return_data
    print("format_data_dict = ", format_data_dict)


def address_transform(addr):
    real_addr_buffer = "".join(addr).split(".")  # 合并list为字符串 用“.”分割字符串获得数据
    if real_addr_buffer[1][2] == 'X':
        data_addr = real_addr_buffer[0] + "." + real_addr_buffer[1][3:] + "." + real_addr_buffer[2]
    elif real_addr_buffer[1][2] == 'D' or real_addr_buffer[1][2] == 'B' or real_addr_buffer[1][2] == 'W':
        data_addr = real_addr_buffer[0] + "." + real_addr_buffer[1][3:]
    return data_addr

# conn_s7()









